#!/usr/bin/php
<?php
/*!
*! PHP script
*! FILE NAME  : cvs2xml.php
*! DESCRIPTION: Convert CVS history/logs data to XML format
*! AUTHOR     : Elphel, Inc.
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!
*!
*/

//echo "<pre>";
$root_dir=realpath('./');
/*
if (count($_SERVER['argv'])<2) {
 $thisScript=$_SERVER['argv'][0];
 echo <<<USAGE
 usage:
 $thisScript <path_to_config_file>


USAGE;
 exit (1);
}
*/
if (count($_SERVER['argv'])<2)
      $conf_file_name="$root_dir/cvs2xml.conf";
else $conf_file_name=$_SERVER['argv'][1];
echo "Using configuration file $conf_file_name\n";
$conf= parse_ini_file  ($conf_file_name, true);
if (array_key_exists('work_dir',$conf)) $root_dir=$conf['work_dir'];
$global_web_template='http://%s.cvs.sourceforge.net/viewvc/%s/';
if (array_key_exists('web_template',$conf)) $global_web_template=$conf['web_template'];
$projects=array();
foreach ($conf as $key=>$value) if (substr($key,0,7)=='project'){
  if (!array_key_exists('local_root',$value)) $value['local_root']=basename($value['root']);
  if (!array_key_exists('web_template',$value)) $value['web_template']=$global_web_template;
  $projects[]=$value;
}
foreach ($projects as $project) {
  $work_dir= $root_dir.'/'.$project['local_root'].'/'.$project['repository'];
  $top_dir= $root_dir.'/'.$project['local_root']; /// Directory commomn to all packages of the same project
  $resultXML=$root_dir.'/'.$project['local_root'].'_'.$project['repository'].'.xml';
  $web_repository=sprintf($project['web_template'],basename($project['root']),basename($project['root']));
  $remote_package=$project['repository'];
  $hist=array();

/// create directories if they do not exist yet

  if (!file_exists  ($top_dir)) {
    !mkdir($top_dir,0777,true) && die("mkdir $top_dir failed, exiting");
  }
  if (!file_exists  ($work_dir)) {
    !mkdir($work_dir,0777,true) && die("mkdir $work_dir failed, exiting");
  }
/// Checkout from the CVS if no 'CVS' directory exists
  if (!file_exists  ($work_dir.'/CVS') || !file_exists  ($work_dir.'/CVS')) {
    echo "Checking out from the CVS\ncd $top_dir && cvs -z3 -d".$project['root']." co -P ".$project['repository']." ...";
    $res=exec("cd $top_dir && cvs -z3 -d".$project['root']." co -P ".$project['repository'],$full_res,$ret);
    if ($ret !=0)  exit ("CVS checkout failed, exiting\n");
    echo "done\n";  ob_flush();  flush();
  }
/// Update CVS repository
  echo "Updating from the CVS\ncd $work_dir && cvs -f -q update -d -P  '.' 2>&1 ...";
  $res=exec("cd $work_dir && cvs -f -q update -d -P  '.' 2>&1",$full_res,$ret);
  if ($ret !=0)  exit ("CVS update failed, exiting\n");
  echo "done\n";  ob_flush();  flush();
///Read CVS history
  echo "Reading 'cvs history -x TFMARE -a' ...";   ob_flush();  flush();
  $res=exec("cd $work_dir; cvs history -x TFMARE -a",$hist,$ret);
  echo "done\n";  ob_flush();  flush();
///     CODE DATE USER [REVISION] [FILE] PATH_IN_REPOSITORY ACTUAL_WORKING_COPY_NAME
  $ahist=array('mode'=>array(),'date'=>array(),'time'=>array(), 'tz'=>array(), 'user'=>array(),'rev'=>array(),'file'=>array(),'dir'=>array());
  foreach ($hist as $key=>$line) {
    $ahist['mode'][]=strtok($line, " \n\t");
    $ahist['date'][]=strtok(" \n\t");
    $ahist['time'][]=strtok(" \n\t");
    $ahist['tz'][]=strtok(" \n\t");
    $ahist['user'][]=strtok(" \n\t");
    $ahist['rev'][]=strtok(" \n\t");
    $ahist['file'][]=strtok(" \n\t");
    $ahist['dir'][]=strtok(" \n\t");
  }
  array_multisort($ahist['date'],SORT_DESC, SORT_STRING, // SORT_NUMERIC, SORT_ASC,SORT_DESC);
                  $ahist['time'],SORT_DESC, SORT_STRING,
                  $ahist['tz'],
                  $ahist['user'],
                  $ahist['dir'],
                  $ahist['file'],
                  $ahist['rev'],
                  $ahist['mode']);
/// Load existent XML file (if any)
  $events=array();
  $old_events=array();
  if (file_exists  ($resultXML)) {
    $xml = simplexml_load_file($resultXML);
    foreach ($xml->children() as $event) {
      $dateTimeUser= ((string) $event->date).((string) $event->time).((string) $event->user);
      if (!array_key_exists($dateTimeUser,$events)) $events[$dateTimeUser]=array();
      $message=array();
      foreach ($event->message->children() as $line) $message[]=(string) $line;
      $files=array();
      foreach ($event->files->children() as $file) {
        $files[]=array ('dir'=> (string) $file->dir,
                       'file'=> (string) $file->file,
                        'rev'=> (string) $file->rev,
                        'url'=> (string) $file->url,
                       'mode'=> (string) $file->mode,
                      'state'=> (string) $file->state,
                'lines_added'=> (string) $file->lines_added,
              'lines_removed'=> (string) $file->lines_removed);
      }
      $events[$dateTimeUser][]=array('project'=>      $project,
                                     'date'=>(string) $event->date,
                                     'time'=>(string) $event->time,
                                       'tz'=>(string) $event->tz,
                                     'user'=>(string) $event->user,
                                    'files'=>$files,
                                  'message'=>$message);
      $old_events[$dateTimeUser]=null;
    }
  }
  $logs=array();
//  continue;
  foreach ($ahist['dir'] as $key=>$dir) {
    if (strpos ($dir,$remote_package)===0) {
/// Was this event already processed before?
       $dateTimeUser= $ahist['date'][$key] . $ahist['time'][$key] . $ahist['user'][$key];
      if (!array_key_exists($dateTimeUser,$old_events))  { /// only counts for old events (got from XML file)

        $local_file=str_replace($remote_package.'/', '', $ahist['dir'][$key].'/'.$ahist['file'][$key]);
        $event=array('date'=>$ahist['date'][$key],
                     'time'=>$ahist['time'][$key],
                       'tz'=>$ahist['tz'][$key],
                     'user'=>$ahist['user'][$key],
                      'rev'=>$ahist['rev'][$key],
                  'message'=>array(),
                    'files'=>array(array('dir'=> $ahist['dir'][$key],
                                        'file'=> $ahist['file'][$key],
                                         'rev'=> $ahist['rev'][$key],
                                        'mode'=> $ahist['mode'][$key])));

         $local_file_esc=str_replace('/','__',$local_file);
        if (!array_key_exists($local_file_esc,$logs)) {
          echo "cd $work_dir; cvs log $local_file\n";
          ob_flush();  flush();
          $res=exec("cd $work_dir; cvs log ".$local_file,$logs[$local_file_esc],$ret);
        }
/// Find needed revision in the log
//echo "Looking for revision ".$ahist['rev'][$key]."\n";
        if (count($logs[$local_file_esc]) ) {
          $i=0;
          $line_num=0;
          while (substr(trim($logs[$local_file_esc][$i]),strlen("revision "))!=$event['rev']) $i++;
           while ((substr(trim($logs[$local_file_esc][$i]),0,20)!='--------------------') &&
                  (substr(trim($logs[$local_file_esc][$i]),0,20)!='====================') &&
                  ($i<count($logs[$local_file_esc]))) {
             $line_num++;
             switch ($line_num) {
               case 1: break; /// we already have revision
               case 2:
                 $unused=array();
                 strtok($logs[$local_file_esc][$i], " \n\t");  ///"date:"
                 strtok(" \n\t"); ///  date
                 strtok(" \n\t"); ///  time;
                 strtok(" \n\t"); /// "author:"
                 strtok(" \n\t"); ///  user;
                 strtok(" \n\t"); /// "state:"
                 $event['files'][0]['state']=rtrim(strtok(" \n\t"),';');
                 strtok(" \n\t"); /// "lines:"
                 $event['files'][0]['lines_added']=ltrim(strtok(" \n\t"),'+')+0; /// lines added
                 $event['files'][0]['lines_removed']=ltrim(strtok(" \n\t"),'-')+0; /// lines removed
                 break;
               default:$event['message'][]=$logs[$local_file_esc][$i];
             }
             $i++;
          }
        }
//print_r($event);
/// try to combine this event with existent one
        if (!array_key_exists($dateTimeUser,$events)) $events[$dateTimeUser]=array();
        $isNewEvent=true;
        foreach ($events[$dateTimeUser] as $index=>$old_event) {
          if (count($old_event['message']) != count($old_event['message'])) continue;
          $isNewMessage=false;
          foreach ($old_event['message'] as $line_index=>$line) if ($event['message'][$line_index]!=$line) {
            $isNewMessage=true;
            break;
          }
          if (!$isNewMessage) { /// same event - just add file
            $isNewEvent=false;
            break;
          }
        }
        if ($isNewEvent) { /// add a new event
            $events[$dateTimeUser][]=$event;
            echo "added event $dateTimeUser\n";
        } else { /// same event - just add file
            $events[$dateTimeUser][$index]['files'][]=$event['files'][0];
            echo "added file to $dateTimeUser\n";
        }
      } else {
//        echo "Old event $dateTimeUser\n";
      }
    }
  }
/// re-sort events in reverse chronological
  $dates=array();
  foreach ($events as $dt=>$event) $dates[]=$dt;
  array_multisort($dates,SORT_DESC, SORT_STRING, // SORT_NUMERIC, SORT_ASC,SORT_DESC);
                  $events);
/// make XML of it
  $xml = new SimpleXMLElement("<?xml version='1.0'?><cvs_$remote_package/>");
  $i=0;
  foreach ($events as $event_set) foreach ($event_set as $event) {
    $xml->addChild ("event");
    $xml->event[$i]->addChild ('date',$event['date']);
    $xml->event[$i]->addChild ('time',$event['time']);
    $xml->event[$i]->addChild ('tz',  $event['tz']);
    $xml->event[$i]->addChild ('user',$event['user']);
    $xml->event[$i]->addChild ('files');
    $xml->event[$i]->addChild ('message');
    for ($j=0;$j<count($event['files']);$j++) {
      $xml->event[$i]->files->addChild ('file');
      $xml->event[$i]->files->file[$j]->addChild ('dir',           $event['files'][$j]['dir']);
      $xml->event[$i]->files->file[$j]->addChild ('file',          $event['files'][$j]['file']);
      $xml->event[$i]->files->file[$j]->addChild ('rev',           $event['files'][$j]['rev']);
      $xml->event[$i]->files->file[$j]->addChild ('url',           htmlspecialchars($web_repository.
                                                                   $event['files'][$j]['dir'].'/'.
                                                                   $event['files'][$j]['file'].
                                                                   '?revision='.$event['files'][$j]['rev'].
                                                                   '&view=markup',ENT_QUOTES));
      $xml->event[$i]->files->file[$j]->addChild ('mode',          $event['files'][$j]['mode']);
      $xml->event[$i]->files->file[$j]->addChild ('state',         $event['files'][$j]['state']);
      $xml->event[$i]->files->file[$j]->addChild ('lines_added',   $event['files'][$j]['lines_added']);
      $xml->event[$i]->files->file[$j]->addChild ('lines_removed', $event['files'][$j]['lines_removed']);
    }
    foreach ($event['message'] as $line)
      $xml->event[$i]->message->addChild ('line', htmlspecialchars($line,ENT_QUOTES));
    $i++;
  }
//$resultXML.="_new.xml";
  $xmlFile=fopen($resultXML,'w+');
  fwrite($xmlFile,$xml->asXML());
  fclose ($xmlFile);
  echo "results are written to $resultXML\n";
}
//echo "</pre>";
?>
