#!/usr/bin/php
<?php
/*!
*! PHP script
*! FILE NAME  : cvsxml2rss.php
*! DESCRIPTION: Converts compiled CVS project XML file to RSS 2.0 feed
*! AUTHOR     : Elphel, Inc.
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!
*!
*/

//$work_dir="/home/andrey/public_html/cvsblog/";

$generator="cvsxml2rss";

//$CSS="http://pundit.elphel.com/test/cvsblog/rss/feed.css";

$root_dir=realpath('./');
$timestamp=0;
$projects=array();
$toFile=false;
$allProjects=true;
  if ($_SERVER['REQUEST_METHOD']=="GET") $args=$_GET;
  else {
   $args=array();
   for ($i=1; $i<count($_SERVER['argv']);$i++) {
     $name=strtok(trim($_SERVER['argv'][$i],'"'),'=');
     $args[strtok($_SERVER['argv'][$i],'=')]=strtok('=');
   }
  }
  if (array_key_exists('conf',$args)) {
     $conf_file_name=$args['conf'];
  } else {
     $conf_file_name="$root_dir/cvs2xml.conf";
  }

  if ($_SERVER['REQUEST_METHOD']=="GET") echo "<pre>\n";
  echo "Using configuration file $conf_file_name\n";
  $conf= parse_ini_file  ($conf_file_name, true);

  $CSS="";
  $URL="http://www.sample.com";
  $titleTemplate="CVS log for Sample project %s";
  $titleTemplateMult="CVS log for Sample projects %s";
  $descriptionTemplate="Combined CVS commit logs for the files of the Sample %s projects.";
  $descriptionTemplateMult="Combined CVS commit logs for the files of the Sample projects %s.";
  $language="en";
  $feedAll="feed";
  $work_dir=$root_dir;
  if (array_key_exists('work_dir',               $conf)) $work_dir=               $conf['work_dir'];
  if (array_key_exists('CSS',                    $conf)) $CSS=                    $conf['CSS'];
  if (array_key_exists('URL',                    $conf)) $URL=                    $conf['URL'];
  if (array_key_exists('titleTemplate',          $conf)) $titleTemplate=          $conf['titleTemplate'];
  if (array_key_exists('titleTemplateMult',      $conf)) $titleTemplateMult=      $conf['titleTemplateMult'];
  if (array_key_exists('descriptionTemplate',    $conf)) $descriptionTemplate=    $conf['descriptionTemplate'];
  if (array_key_exists('descriptionTemplateMult',$conf)) $descriptionTemplateMult=$conf['descriptionTemplateMult'];
  if (array_key_exists('language',               $conf)) $language=               $conf['language'];
  if (array_key_exists('feedAll',                $conf)) $feedAll=                $conf['feedAll'];

$projectsList=array();
foreach ($conf as $key=>$value) if (substr($key,0,7)=='project'){
  if (!array_key_exists('local_root',$value)) $value['local_root']=basename($value['root']);
  if (!array_key_exists('web_template',$value)) $value['web_template']=$global_web_template;
  $projectsList[]=$value;
}

   foreach ($args as $key=>$value) switch ($key) {
      case 'tofile':
        $toFile=true;
        break;
      case 'p':
        $allProjects=false;
        $value=explode(',',$value);
        for ($i=0; $i < count($projectsList); $i++) {
            if (in_array($projectsList[$i]['repository'],$value)) $projects[$i]=$i;
        }
        break;
      case 'd': ///YYYY-MM-DD
        $arrDate=array();
        $tok=strtok($value,"-/:+");
        while ($tok !== false) {
          $arrDate[]=$tok+0;
          $tok = strtok("-/:+");
        }
        if ($arrDate[0]<100) $arrDate[0]+=2000;
        $earliestDate=sprintf("%04d-%02d-%02d",$arrDate[0],$arrDate[1],$arrDate[2]);
        break;
      case 'ftp':
        $value=explode(',',$value);
        if (count($value)>=4) {
          $toFile=true; /// We need first to save to a file
          $ftp_server=   $value[0];
          $ftp_user_name=$value[1];
          $ftp_user_pass=$value[2];
          $ftp_dir=      rtrim($value[3],'/').'/';
        }
        break;
   }
   if ($allProjects) for ($i=0; $i < count($projectsList); $i++) $projects[$i]=$i;
//   print_r ($projects);
//   print_r ($args);
//   print_r($earliestDate);
   $events=array();
   $dateTimes=array();
   $projectRSS="";
   $projectNames="";
   $count=count($projects);
   foreach ($projects as $index) {
      $count--;
      $project=$projectsList[$index]['repository'];
      $projectRSS.="_".$project;
      $projectXML= $work_dir.'/'.$projectsList[$index]['local_root'].'_'.$project.'.xml';
//echo "work_dir=$work_dir\n";
//echo "root_dir=$root_dir\n";
//echo "projectXML=$projectXML\n";
      if ($projectNames=="") $projectNames = $project;
      else if ($count>0)     $projectNames.=', '.$project;
      else                   $projectNames.=' and '.$project; 
      addProjectXML ($events,$dateTimes, $project, $projectXML,$earliestDate);
   }
   array_multisort($dateTimes,SORT_DESC, SORT_STRING, $events);
//   print_r($events);
   if (count($events)==0) {
     echo "No events found\n";
     exit(1);
   }
   $singleProject=count($projects)==1;
   if ($singleProject) {
     $title=        sprintf($titleTemplate, $projectNames);
     $description=  sprintf($descriptionTemplate, $projectNames);
   } else if ($allProjects) {
     $title=        sprintf($titleTemplateMult, "");
     $description=  sprintf($descriptionTemplateMult, "");
   } else {
     $title=        sprintf($titleTemplateMult, $projectNames);
     $description=  sprintf($descriptionTemplateMult,$projectNames);
   }
   $rss=makeRSS($events,
                $title,
                $description,
                $language,
                $generator,
                $URL,
                $singleProject,
                $css);  //not yet used
   if ($toFile) {
     if ($allProjects) $projectRSS= $feedAll;
     $projectRSSName=ltrim($projectRSS,'_').'.rss';
     $projectRSS=$work_dir.'/'.$projectRSSName;
     if (file_exists ($projectRSS)) unlink($projectRSS);
     $fileRSS=fopen ($projectRSS,"w+");
     fwrite ($fileRSS,$rss);
     fclose($fileRSS);
     chmod  ($projectRSS, 0666); /// to alternate between command line/web server - they are likely to be different users
     echo "Result is written to $projectRSS\n";
     if ($ftp_server) {
       $ftp_result= uploadFTP($ftp_server,
                              $ftp_user_name,
                              $ftp_user_pass,
                              $ftp_dir.$projectRSSName,
                              $projectRSS,
                              0644);
       if ($ftp_result) {
         echo "$projectRSS uploaded via FTP  to $ftp_server as $ftp_dir$projectRSSName\n";
       } else {
         echo "FTP upload to $ftp_server as $ftp_dir$projectRSSName failed\n";
       }
     }
   } else {
     echo $rss;
   }
   
   if ($_SERVER['REQUEST_METHOD']=="GET") echo "</pre>\n";
   exit (0);
/// =============== functions ===============

 function addProjectXML (&$events,&$dateTimes, $project, $projectXML, $earliestDate) {
 echo "Processing $projectXML\n";
    $xml = simplexml_load_file($projectXML);
    foreach ($xml->children() as $event) if ((string)$event->date > $earliestDate){
      $dateTime= ((string) $event->date).((string) $event->time);
      if (!array_key_exists($dateTime,$events)) $events[$dateTime]=array();
      $message=array();
      foreach ($event->message->children() as $line) $message[]=(string) $line;
      $files=array();
      foreach ($event->files->children() as $file) {
        $files[]=array ('dir'=> (string) $file->dir,
                       'file'=> (string) $file->file,
                        'rev'=> (string) $file->rev,
                        'url'=> (string) $file->url,
                       'mode'=> (string) $file->mode,
                      'state'=> (string) $file->state,
                'lines_added'=> (string) $file->lines_added,
              'lines_removed'=> (string) $file->lines_removed);
      }


      $events[$dateTime][]=array('project'=>$project,'date'=>(string) $event->date,'time'=>(string) $event->time,'user'=>(string)$event->user,'files'=>$files,'message'=>$message);
      $dateTimes[$dateTime]=$dateTime;
    }
  }

 function  makeRSS(&$events,
                    $title,
                    $description,
                    $language,
                    $generator,
                    $link,
                    $singleProject,
                    $css) {
   $emptyTemplate="Unfortunately %s was too busy to leave any commit message";
   $lastBuildDate=date('r');
   $rss=new xmlWriter();
   $rss->openMemory();
   $rss->startDocument('1.0','UTF-8');
//    $xw->startDtd('html','-//WAPFORUM//DTD XHTML Mobile 1.0//EN', 'http://www.wapforum.org/DTD/xhtml-mobile10.dtd');
   $rss->startElement ('rss'); // <rss>
   $rss->writeAttribute( 'xmlns:dc',"http://purl.org/dc/elements/1.1/");
   $rss->writeAttribute( 'version', '2.0');
   $rss->startElement ("channel");
   $rss->writeElement ('title',$title);
   $rss->writeElement ('link', $link);
   $rss->writeElement ('description',$description);
   $rss->writeElement ('language', $language);
   $rss->writeElement ('generator', $generator);
   $rss->writeElement ('lastBuildDate', $lastBuildDate);
   $item=0;
   foreach ($events as $event_date) {
//    print_r($event_date);
    foreach ($event_date as $event){
     $project=$event['files'][0]['dir'];
     $project=strtok($project,'/');
     $user=sprintf("<a href='https://sourceforge.net/users/%s'>%s</a>",$event['user'],$event['user']);
     if (!array_key_exists('message',$event) || !count($event['message']) || (strpos($event['message'][0],"empty log message"))) {
        $messageTitle= sprintf($emptyTemplate,$event['user']);
        $event['message']=array(sprintf($emptyTemplate,$user));
     } else $messageTitle= $event['message'][0];
     $commits="<ul>";
     foreach ($event['files'] as $file) {
       switch ($file->mode) {
         case 'R':
              $commits.= sprintf ("<li>Removed  <a href='%s'>%s rev%s</a></li>\n", htmlspecialchars($file['url'],ENT_QUOTES),$file['file'],$file['rev']);
              break;
         case 'A':
              $commits.= sprintf ("<li>Added    <a href='%s'>%s rev%s</a></li>\n", htmlspecialchars($file['url'],ENT_QUOTES),$file['file'],$file['rev']);
              break;
         default:
              $commits.= sprintf ("<li>Modified <a href='%s'>%s rev%s</a> - added %s, removed %s</li>\n",
                                   htmlspecialchars($file['url'],ENT_QUOTES),
                                   $file['file'],
                                   $file['rev'],
                                   lines($file['lines_added']),
                                   lines($file['lines_removed']) );
         }
     }
     $commits.="</ul>";
     if ($singleProject) {
       $itemTitle=sprintf("By %s: %s%s",               $event['user'],$messageTitle,(count($event['message'])>1)?'...':'');
     } else {
       $itemTitle=sprintf("[%s] By %s: %s%s",$project, $event['user'],$messageTitle,(count($event['message'])>1)?'...':'');
     }
     $itemDescription=sprintf("%s committed changes to the Elphel project %s CVS:<br/><i>%s</i>%s",$user,$project,implode(" ", $event['message']), $commits?('<br/>'.$commits):'');
     $itemDate=date ('r', gmmktime (substr($event['time'],0,2), // int $hour
                                    substr($event['time'],3,2), // int $minute
                                                          0,  // int $second
                                    substr($event['date'],5,2), // int $month
                                    substr($event['date'],8,2), // int $day
                                    substr($event['date'],0,4))); // int $year
     if (count($event['files'])==1) $link=$event['files'][0]['url'];
     else $link='';
     $rss->startElement ('item');
     $rss->writeElement   ('title',       $itemTitle);
     $rss->startElement   ('description');
     $rss->writeCData       ($itemDescription);
     $rss->endElement     ();
     $rss->writeElement   ('pubDate',     $itemDate);
     if ($link) {
       $rss->writeElement   ('link',        $link);
       $rss->writeElement   ('guid',        $link);
     }
     $rss->endElement   ();
     $item++;
    }
   }
   $rss->endElement   ();
   $rss->endElement ();
   return $rss->outputMemory(true);   
 }

 function lines($nlines) { return ($nlines=="1") ? "one line":(($nlines=="0")? "none":($nlines." lines")); }
/// see if the file name is one of the binaries or automatically generated (as in Xilinx WebPack) - not to count lines
function uploadFTP($ftp_server,$ftp_user_name,$ftp_user_pass,$destination_file,$source_file,$mode='') {
$result=true;
// set up basic connection
$conn_id = ftp_connect($ftp_server);
 if (!$conn_id) return false;

// login with username and password
$login_result = ftp_login($conn_id, $ftp_user_name, $ftp_user_pass);

// check connection
if ((!$conn_id) || (!$login_result)) {
        echo "FTP connection has failed!";
        echo "Attempted to connect to $ftp_server for user $ftp_user_name";
        return false;
    } else {
        echo "Connected to $ftp_server, for user $ftp_user_name";
    }
// upload the file
    $upload = ftp_put($conn_id, $destination_file, $source_file, FTP_BINARY);
// check upload status
if (!$upload) {
        echo "FTP upload has failed -  $source_file to $ftp_server as $destination_file";
        $result=false;
    } else {
        echo "Uploaded $source_file to $ftp_server as $destination_file";
    }
    if ($result && ($mode!=="")) {
      if (ftp_chmod($conn_id, $mode, $destination_file) !== false) {
        echo "$destination_file chmoded successfully to $mode\n";
      } else {
        echo "could not chmod $destination_file\n";
        $result=false;
      }
    }
// close the FTP stream
    ftp_close($conn_id); 
    return $result;
}
?>
