<?php
/*!
*! PHP script
*! FILE NAME  : showcvsblog.php
*! DESCRIPTION: Display XML data with CVS history/logs
*! AUTHOR     : Elphel, Inc.
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!
*!
*/
//$url="http://irc.elphel.com/cvslogs.xml";
//$url="/home/andrey/public_html/cvslogs71.xml";
//echo "<pre>\n";print_r($_GET);echo "</pre>\n";
$url_prefix=realpath('./');
$root_dir=  realpath('./');
///============================================
$allProjects=true;
  if ($_SERVER['REQUEST_METHOD']=="GET") $args=$_GET;
  else {
   $args=array();
   for ($i=1; $i<count($_SERVER['argv']);$i++) {
     $name=strtok(trim($_SERVER['argv'][$i],'"'),'=');
     $args[strtok($_SERVER['argv'][$i],'=')]=strtok('=');
   }
  }
  if (array_key_exists('conf',$args)) {
     $conf_file_name=$args['conf'];
  } else {
     $conf_file_name="$root_dir/cvs2xml.conf";
  }
  $conf= parse_ini_file  ($conf_file_name, true);
  if (array_key_exists('url_prefix',   $conf)) $url_prefix=  $conf['url_prefix'];

  $projectsList=array();
  foreach ($conf as $key=>$value) if (substr($key,0,7)=='project'){
    if (!array_key_exists('local_root',$value)) $value['local_root']=basename($value['root']);
    if (!array_key_exists('web_template',$value)) $value['web_template']=$global_web_template;
    $projectsList[]=$value;
  }
  $project_numbers=array();
  $users=array();
  $projects=array();
  $make_stats=false;
//array_key_exists('stats',$_GET);
  $print=true;
//!array_key_exists('nolog',$_GET);

   foreach ($args as $key=>$value) switch ($key) {
      case 'stats':
        $make_stats=true;
        break;
      case 'nolog':
        $print=false;
        break;
      case 'p':
        $allProjects=false;
        $value=explode(',',$value);
        for ($i=0; $i < count($projectsList); $i++) {
            if (in_array($projectsList[$i]['repository'],$value)) $project_numbers[$i]=$i;
        }
        break;
      case 'd': ///YYYY-MM-DD
        $arrDate=array();
        $tok=strtok($value,"-/:+");
        while ($tok !== false) {
          $arrDate[]=$tok+0;
          $tok = strtok("-/:+");
        }
        if ($arrDate[0]<100) $arrDate[0]+=2000;
        $earliestDate=sprintf("%04d-%02d-%02d",$arrDate[0],$arrDate[1],$arrDate[2]);
        break;
   }
   if ($allProjects) for ($i=0; $i < count($projectsList); $i++) $project_numbers[$i]=$i;

   foreach ($project_numbers as $index) {
     $project=$projectsList[$index]['repository'];
     $projectXML= $url_prefix.'/'.$projectsList[$index]['local_root'].'_'.$project.'.xml';
     $projects[]=processProject($users,$projectXML,$print);
   }
   if (!$make_stats) exit (0);
   printf("<br/><h3>projects included:<ul>");
   foreach ($projects as $project) printf("<li>%s</li>\n",$project);
   printf("</ul></h3>\n");
   processUsers($users);
   $months=array();
   $alines=array();
   $commits=array();
   foreach ($project_numbers as $index) {
     $project=$projectsList[$index]['repository'];
     $projectXML= $url_prefix.'/'.$projectsList[$index]['local_root'].'_'.$project.'.xml';
     $projects[]=processProject($users,$projectXML,$print);
     processProjectMonths($projectXML,&$months, &$alines, &$commits);
   }
   foreach ($months as $month=>$a) $months[$month]=$month;
   foreach ($alines as $user=>$stats) {
      $months1=$months; //copy
      array_multisort($months1,SORT_ASC,  SORT_STRING,
                      $alines[$user],
                      $commits[$user]);
   }
   echo "<br/><hr/><br/>";
   printf("<h4>Number of lines committed (per user, per month)</h4>");
   printCalend($alines);
   echo "<br/><hr/><br/>";
   printf("<h4>Number of files committed (per user, per month)</h4>");
   printCalend($commits);
   exit (0);
/// =============== functions ===============
 function lines($nlines) { return ($nlines=="1") ? "one line":(($nlines=="0")? "none":($nlines." lines")); }
/// see if the file name is one of the binaries or automatically generated (as in Xilinx WebPack) - not to count lines
 function binfiles($name) {
   $binAutoExt=array("_pad.txt",".bit",".syr",".par",".mrp",".xcf",".png",".gif",".zip",".gz",".pdf");
   foreach ($binAutoExt as $ext) if (substr($name,strlen($name)-strlen($ext))==$ext) return true;
   return false;
 }
 function printCalend($arr) {
   printf("<table  border='1'>\n");
   printf("<tr style='text-align:center'><td>&nbsp;</td>");
   reset($arr);
   $first=current($arr);
   foreach ($first as $month=>$data) printf("<td>%s<br/>%s</td>",substr($month,0,4),substr($month,5,2));
   printf("</tr>\n");
   foreach ($arr as $user => $data) {
    $linked_user=sprintf("<a href='https://sourceforge.net/users/%s'>%s</a>",$user,$user);
     printf("<tr style='text-align:right'><td>%s</td>",$linked_user);
      
       foreach ($data as $monthly_val) printf ("<td>%d</td>",$monthly_val);
     printf("</tr>");
   }
   printf("</table>\n");
 }
 function processUsers(&$users) {
   $rank=array();
   $sum_added=0;
   $sum_commits=0;
   $sum_committed_files=0;
   foreach ($users as $user) {
//     $rank[]=$user['added_lines'];
     $rank[]=$user['commits'];
     $sum_added+=$user['added_lines'];
     $sum_commits+=$user['commits'];
     $sum_committed_files+=$user['committed_files'];

   }
   array_multisort($rank,SORT_DESC,  SORT_NUMERIC, $users);
   printf ("<table border='1'>\n");
   printf ("<tr style='text-align:center'><td>&nbsp;</td><td>Name</td><td>Added<br/>Lines</td><td>Share</br>(%%)</td><td>New</br>Lines(%%)</td><td>Commits<br/>&nbsp;</td><td>Commits<br/>(%%)</td><td>Committed<br/>files</td><td>Committed<br/>files(%%)</td><td>No Msg</br>(%%)</td><td>Files<br/>touched</td></tr>\n");
   $n=1;
   foreach ($users as $user=>$attr) {
     printf ("<tr style='text-align:right'><td>&nbsp;%d&nbsp;</td><td>%s</td><td>%d</td><td>%3.2f</td><td>%3.2f</td><td>%d</td><td>%3.2f</td><td>%d</td><td>%3.2f</td><td>%3.2f</td><td>%d</td></tr>\n",
     $n++,
     sprintf("<a href='https://sourceforge.net/users/%s'>%s</a>",$user,$user),
     $attr['added_lines'],
     100*$attr['added_lines']/$sum_added,
     $attr['added_lines']?(100*($attr['added_lines']-$attr['removed_lines'])/$attr['added_lines']):0,
     $attr['commits'],
     100*$attr['commits']/$sum_commits,
     $attr['committed_files'],
     100*$attr['committed_files']/$sum_committed_files,
     100*$attr['empty']/$attr['commits'],
     count($attr['files']));
   }
   printf ("</table>\n");

 }
 function processProjectMonths($url,&$months, &$alines, &$commits) {
   $xml = simplexml_load_file($url);
   foreach ($xml->children() as $event) {
//     $month=substr($event->date,0,4).substr($event->date,5,2);
     $month=substr($event->date,0,7);
     $user=(string)$event->user;
     if (!array_key_exists($month,$months)) {
       $months[$month]=0;
/// add month to all users, all arrays
       foreach ($alines as $u=>$arr) {
         $alines[$u][$month]=0;
         $commits[$u][$month]=0;
       }
     }
/// New users?
     if (!array_key_exists($user,$alines)) {
       $alines[$user]= $months; // all zeroes for known months
       $commits[$user]=$months; // all zeroes for known months
     }
/// Now - add lines and commits
     $commits[$user][$month]+=count($event->files->children());/// count each committed file as 1 (5 committed at once will add 5)
     foreach ($event->files->children() as $file) if (($file->mode=="M") && (!binfiles($file->file)))$alines[$user][$month]+=$file->lines_added;
   }
 }

 function processProject(&$users,$url,$print) {

//   global $users;
   $project="";
//echo "<h2>$url</h2>\n";
   $xml = simplexml_load_file($url);
   foreach ($xml->children() as $event) {
     if ($project=="") {
       $project=$event->files->children();
       $project=$project[0]->dir;
       $project=strtok($project,'/');
       if ($print) printf ("<br/><center><h3>Project %s</h3></center><br/>\n",$project);
     }
     if (!array_key_exists(((string)$event->user), $users))
           $users[(string)$event->user]= array('empty'=>0,'commits'=>0,'committed_files'=>0,'added_lines'=>0,'removed_lines'=>0, 'added_files'=>0,'removed_files'=>0, 'modified_files'=>0, 'files'=>array());
///counting all files committed as 1 act
     $users[(string)$event->user]['commits']++;
///counting each file commited separately
     $users[(string)$event->user]['committed_files']+=count($event->files->children());

     $user=sprintf("<a href='https://sourceforge.net/users/%s'>%s</a>",$event->user,$event->user);
     if ($print) printf("<p>On %s at %s UTC <b>%s</b> committed changes to the CVS with the following message</p>",$event->date,$event->time,$user);
     $message=$event->message->children();
     if ((!$message) || !count($message) || (strpos($message,"empty log message"))) {
        $message=array(sprintf("Unfortunately %s was too busy to leave any commit message",$user));
        $users[(string)$event->user]['empty']++;
     }
     if ($print) {
       printf("<p><i>");
       foreach ($message as $line) {
         printf ("%s<br/>\n",$line);
       }
       printf("</i></p>");
       printf ("<ul>\n");
     }
     foreach ($event->files->children() as $file) {
       $full_name=$file->dir ."_".$file->file;
       $users[(string)$event->user]['files'][$full_name]++; /// will it work?
       switch ($file->mode) {
         case 'R':
              if ($print)  printf ("<li>Removed  <a href='%s'>%s rev%s</a></li>\n", $file->url,$file->file,$file->rev);
              $users[(string)$event->user]['removed_files']++;
              break;
         case 'A':
              if ($print) printf ("<li>Added    <a href='%s'>%s rev%s</a></li>\n", $file->url,$file->file,$file->rev);
              $users[(string)$event->user]['added_files']++;
               break;
         default:
              if ($print) printf ("<li>Modified <a href='%s'>%s rev%s</a> - added %s, removed %s</li>\n",
              $file->url,$file->file,$file->rev,lines($file->lines_added),lines($file->lines_removed) );
              $users[(string)$event->user]['modified_files'] ++;
              if (!binfiles($file->file)) {
                  $users[(string)$event->user]['added_lines']+= $file->lines_added;
///                  if ($file->lines_added > 200) echo "##########"; // just looking for automatic files
              }
              if (!binfiles($file->file)) $users[(string)$event->user]['removed_lines']+= $file->lines_removed;
         }
     }
     if ($print) printf ("</ul>\n<hr/>");
   }
   return $project;
 }
?>
